'use strict';

var FrameStorageListener = require('./utils/frame-storage-listener');
var LocalStorageStrategy = require('./strategies/local-storage');
var FrameStorageStrategy = require('./strategies/frame-storage');
var WixStorageStrategy = require('./strategies/wix-storage');
var CachedStorageStrategy = require('./strategies/cached-storage');

var _require = require('./utils/constants'),
    NOT_FOUND = _require.NOT_FOUND;

var BaseStorage = require('./base-storage');
var DataCapsule = require('./data-capsule');

function LocalStorageCapsule(options) {
  return new DataCapsule(Object.assign({}, options, { strategy: new LocalStorageStrategy() }));
}

function LocalStorageCachedCapsule(options) {
  return new DataCapsule(Object.assign({}, options, {
    strategy: new CachedStorageStrategy({ remoteStrategy: options.remoteStrategy })
  }));
}

module.exports = {
  NOT_FOUND: NOT_FOUND,
  BaseStorage: BaseStorage,
  DataCapsule: DataCapsule,
  FrameStorageListener: FrameStorageListener,
  FrameStorageStrategy: FrameStorageStrategy,
  LocalStorageStrategy: LocalStorageStrategy,
  LocalStorageCapsule: LocalStorageCapsule,
  WixStorageStrategy: WixStorageStrategy,
  CachedStorageStrategy: CachedStorageStrategy,
  LocalStorageCachedCapsule: LocalStorageCachedCapsule
};