'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BaseStorage = require('../src/base-storage');

var _require = require('chai'),
    expect = _require.expect;

describe('base-storage', function () {
  it('should throw if instantiating with pure methods', function () {
    var SomeStorage = function (_BaseStorage) {
      _inherits(SomeStorage, _BaseStorage);

      function SomeStorage() {
        _classCallCheck(this, SomeStorage);

        return _possibleConstructorReturn(this, (SomeStorage.__proto__ || Object.getPrototypeOf(SomeStorage)).apply(this, arguments));
      }

      return SomeStorage;
    }(BaseStorage);

    expect(function () {
      return new SomeStorage();
    }).to.throw('must be overriden');
  });

  it('should not throw if you override the methods', function () {
    var SomeStorage = function (_BaseStorage2) {
      _inherits(SomeStorage, _BaseStorage2);

      function SomeStorage() {
        _classCallCheck(this, SomeStorage);

        return _possibleConstructorReturn(this, (SomeStorage.__proto__ || Object.getPrototypeOf(SomeStorage)).apply(this, arguments));
      }

      _createClass(SomeStorage, [{
        key: 'setItem',
        value: function setItem(key, value, options) {
          _get(SomeStorage.prototype.__proto__ || Object.getPrototypeOf(SomeStorage.prototype), 'setItem', this).call(this, key, value, options);
        }
      }, {
        key: 'getItem',
        value: function getItem(key, options) {
          _get(SomeStorage.prototype.__proto__ || Object.getPrototypeOf(SomeStorage.prototype), 'getItem', this).call(this, key, options);
        }
      }, {
        key: 'removeItem',
        value: function removeItem(key, options) {
          _get(SomeStorage.prototype.__proto__ || Object.getPrototypeOf(SomeStorage.prototype), 'removeItem', this).call(this, key, options);
        }
      }, {
        key: 'getAllItems',
        value: function getAllItems(options) {
          _get(SomeStorage.prototype.__proto__ || Object.getPrototypeOf(SomeStorage.prototype), 'getAllItems', this).call(this, options);
        }
      }]);

      return SomeStorage;
    }(BaseStorage);

    expect(function () {
      return new SomeStorage();
    }).not.to.throw();

    // following expectations are totally unnecessary
    // sole purpose is to have 100% coverage :P
    expect(function () {
      return new SomeStorage().setItem();
    }).to.throw();
    expect(function () {
      return new SomeStorage().getItem();
    }).to.throw();
    expect(function () {
      return new SomeStorage().removeItem();
    }).to.throw();
    expect(function () {
      return new SomeStorage().getAllItems();
    }).to.throw();
  });
});